\ dcf77D.fth by CWE
\ For Pollin DCF-Modul DCF1

\ NeoPixel Ring on Pin 1
12 3 * bytes ledarray

: clrall
    12 3 * FOR 0 ledarray I + C! NEXT
    ledarray 12 RGBS ;
    
: setc ( color led -- ) \ 0 grn 1 red 2 blue
    3 * + ledarray + 1 SWAP C! \ set brightness 1 
    ledarray 12 RGBS ;
    
: clrled ( led -- ) \ 0 grn 1 red 2 blue
    3 * ledarray + 
    DUP 0 SWAP C! 
    DUP 1+ 0 SWAP C! 
    2 + 0 SWAP C! 
    ledarray 12 RGBS ;

{
: spinled 
    120 FOR 
        1 I 12 MOD setc 
        100 ms
        clrall
        1 ms
    NEXT ;
}

: ledtime 
    clrall
    TIME@ HMS
    1 ms 12 MOD 1 SWAP setc \ hours red
    1 ms 5 / 0 SWAP setc \ minutes green
    1 ms 5 / 2 SWAP setc \ seconds blue
;

long oldtime#

: showtime 
    1 RGBPIN
    BEGIN
        oldtime# @ TIME@ <> IF
            TIME@ oldtime# !
            ledtime
        THEN
    AGAIN
;


171500 TIME! 
\ ' showtime 4 RUN

\ #################################################################
\ DCF77 starts here
\ Pollin DCF1 Modul with positive pulses
\ Data on Pin 3, PON (enable=LOW on Pin 2)
\ LED on Pin 8
\ http://endorphino.de/projects/electronics/timemanipulator/bilder/timemanipulator_dcf77code_01.gif

: >ONeg ( n1 n2 -- FLAG ) \ prevent stalling on overflow / midnight
    2DUP > \ n1 > n2 
    ROT ROT DROP 0< \ n1 negative
    OR ;

: dcfIn 
    3 PIN@ IF 8 HIGH ELSE 8 LOW THEN ;

long secCnt# 

long bits#

long lasttime# 0 lasttime# ! 

long lowtime# 

long hightime#   

long lastLowHigh# 

long lastHighLow#


: dcfInit \ activate PON at module
    2 HIGH
    300 ms
    2 LOW
    0 lastLowHigh# !
    0 lastHighLow# !
;

\ dcfInit


\ Suppress short pulses
: waitLH
    BEGIN
        BEGIN 3 PIN@ 0 <> UNTIL 
    time @ lastHighLow# @ - 30 >ONeg UNTIL
;

: waitHL
    BEGIN
        BEGIN 3 PIN@ 0 = UNTIL 
    time @ lastLowHigh# @ - 30 >ONeg UNTIL
;

 
: dcfOntime ( -- ) 
    BEGIN 3 PIN@ 0 = UNTIL
    waitLH
        8 HIGH 
        time @ 
        DUP lastLowHigh# @ - lowtime# !
        lastLowHigh# !
    waitHL
        8 LOW 
        time @
        DUP lastLowHigh# @ - hightime# !  
        lastHighLow# !
;

: dcfDecode \ long pulse, output format hh.mm.ss like time@
    secCnt# @ SWITCH
    21 CASE  100 bits# +! BREAK \ 1 minute
    22 CASE  200 bits# +! BREAK
    23 CASE  400 bits# +! BREAK
    24 CASE  800 bits# +! BREAK
    25 CASE 1000 bits# +! BREAK
    26 CASE 2000 bits# +! BREAK
    27 CASE 4000 bits# +! BREAK

    29 CASE  10000 bits# +! BREAK \ 1 hour
    30 CASE  20000 bits# +! BREAK
    31 CASE  40000 bits# +! BREAK
    32 CASE  80000 bits# +! BREAK
    33 CASE 100000 bits# +! BREAK
    34 CASE 200000 bits# +! BREAK
;

: dcfGetBits 
    lowtime# @ 1500 > IF \ Minute completed
        0 secCnt# !
    ELSE
        hightime# @ 40 > IF
            secCnt# ++                
            hightime# @ 160 > IF dcfDecode THEN
        THEN
    THEN
;


: dcfSetTime \ Set the software clock of Tachyon after 2 consecutive receptions
    secCnt# @ 1 = IF
        lasttime# @ 100 + bits# @ = IF 
            bits# @ 0 SDT!
            0 lastLowHigh# !
            0 lastHighLow# ! 
            \ 10 ms CR green PEN ." Time Set " 
        THEN 
        bits# @ lasttime# ! 
        0 bits# ! 
    THEN 
;        


: dcfShow \ For debugging 
    KEY DROP
    dcfInit
    BEGIN
        \ dcfIn
        dcfOntime        
        dcfGetBits
        CR secCnt# @ DUP 1 = IF CR red PEN THEN
        TIME@ . lasttime# @ . . lowtime# @ . hightime# @ . bits# @ .
        dcfSetTime
        white PEN
    KEY UNTIL 
; 


: dcfLoop \ Task for a separate cog
    1 RGBPIN
    dcfInit
    BEGIN
        dcfOntime        
        dcfGetBits
        dcfSetTime

        oldtime# @ TIME@ <> IF \ show it on the Neopixel Ring
            TIME@ oldtime# !
            ledtime
        THEN
    AGAIN
;

' dcfLoop 4 RUN 

: .time 
    KEY DROP
    BEGIN
        1000 ms
        CR TIME@ . lasttime# @ . bits# @ .
    KEY UNTIL ;

.time 
